#!/bin/sh
# Maintained by: toleda for: github.com/toleda/graphics_Intel_framebuffers
# File: graphics_intel_hd4k_capri-a-90_patch.command_v1.0
#
# Desktop HD4000 HDMI audio AppleIntelFramebufferCapri.kext edit
# Edits capri framebuffer 0A 00 66 01 for HDMI audio, additional dsdt edits/ssdt required
# The patch enables HDMI audio, the maximum number of HDMI audio devices supported is 1.
#
# NOTES: 
# 1. Run this patch file only once on a native AppleIntelFramebufferCapri.kext.
#
# Requirements
# 1. 10.9 or newer
# 2. HD4000 Graphics
# 3. AppleIntelFramebufferCapri.kext_v8.18.26 or newer
#
# Installation
# 1. Downloads/graphics_intel_hd4k_capri-a-90_patch.command
# 2. Double click graphics_intel_hd4k_capri-a-90_patch.command
# 3. Enter password at prompt
#
echo " "
echo "Agreement"
echo "The graphics_intel_hd4k_capri-a-90_patch is for personal use only.  Do not"
echo "distribute the patch or the resulting patched AppleIntelFramebufferCapri.kext" 
echo "for any reason without permission. The graphics_intel_hd4k_capri-a-90_patch"
echo "is provided as is and without any kind of warranty."
echo " "
echo "graphics_intel_hd4k_capri-a-90_patch.command_v1.0"
echo "Copy S/L/E/AppleIntelFramebufferAzul.kext to Desktop."
cp -R /System/Library/Extensions/AppleIntelFramebufferCapri.kext Desktop/AppleIntelFramebufferCapri-orig.kext

echo "Patch binary ..."
sudo perl -pi -e 's|\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x05\x00\x00\x00\x04\x00\x00\x07\x01\x00\x00\x03\x04\x00\x00\x00\x04\x00\x00\x07\x01\x00\x00\x04\x06\x00\x00\x00\x08\x00\x00\x06\x00\x00\x00\x00\x00\x00\x00\x01\x00\x00\x00\x40\x00\x00\x00|\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x00\x02\x05\x00\x00\x00\x04\x00\x00\x07\x01\x00\x00\x03\x04\x00\x00\x00\x08\x00\x00\x06\x00\x00\x00\x04\x06\x00\x00\x00\x08\x00\x00\x06\x00\x00\x00\x00\x00\x00\x00\x01\x00\x00\x00\x40\x00\x00\x00|g' /System/Library/Extensions/AppleIntelFramebufferCapri.kext/Contents/MacOS/AppleIntelFramebufferCapri

echo "Fix permissions ..."
sudo chown -R root:wheel /System/Library/Extensions/AppleIntelFramebufferCapri.kext

echo "Kernel cache..."
sudo touch /System/Library/Extensions

echo "Finished, restart required."